=== debian/changelog ===
apitrace (7.1+git20160531.2d78bef0+repack-1.1ubuntu1) zesty; urgency=medium

  * debian/control:
    - Don't build-depend on obsolete libgles1-mesa-dev (Closes: #855119)

 -- Jeremy Bicha <jbicha@ubuntu.com>  Sun, 19 Mar 2017 20:15:11 -0400

apitrace (7.1+git20160531.2d78bef0+repack-1.1build2) yakkety; urgency=medium

  * No-change rebuild for glibc 2.24.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 12 Aug 2016 08:23:03 +0000

apitrace (7.1+git20160531.2d78bef0+repack-1.1build1) yakkety; urgency=medium

  * No-change rebuild against libprocps6

 -- Martin Pitt <martin.pitt@ubuntu.com>  Tue, 12 Jul 2016 18:34:16 +0200

apitrace (7.1+git20160531.2d78bef0+repack-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * d/rules: fix Built-Using using source package instead binary name.
    (Closes: #826355)
  * d/{control,rules}: enable waffle support.
    (Closes: #826623)

 -- Héctor Orón Martínez <zumbi@debian.org>  Thu, 09 Jun 2016 18:29:55 +0200

apitrace (7.1+git20160531.2d78bef0+repack-1) unstable; urgency=medium

  [ Christopher James Halse Rogers ]
  * New upstream release (Closes: #823834)
  * Acknowledge NMU. Thanks, Tobias Fost!
  * debian/patches: refresh patches for new upstream version.
  * debian/copyright:
    + Remove thirdparty/snappy stanza; now stripped from tarball
    + Add new thirdparty/brotli stanza
    + Add new thirdparty/crc32c stanza
  * debian/rules:
    + Add Built-Using substitution for libsnappy-dev; we now use the packaged
      -fPIC static archive.

 -- Timo Aaltonen <tjaalton@debian.org>  Fri, 03 Jun 2016 09:58:02 +0300

apitrace (6.1+git20150626.62ad71c6+repack-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * libpng1.6 Transition: Change B-D on libpng12-dev to libpng-dev only
    (Closes: #819428)

 -- Tobias Frost <tobi@debian.org>  Mon, 28 Mar 2016 14:41:54 +0200
